import { Component, OnInit, ViewChild } from '@angular/core';
import { STColumn, STComponent } from '@delon/abc/st';
import { SFComponent, SFDateWidgetSchema, SFSchema, SFSchemaEnum, SFSelectWidgetSchema, SFUISchema } from '@delon/form';
import { ModalHelper, _HttpClient } from '@delon/theme';
import { NzModalService } from 'ng-zorro-antd/modal';
import { map } from 'rxjs/operators';
import { OrderManagementService } from '../../services/order-management.service';
import { UpdateFreightComponent } from '../../modal/bulk/update-freight/update-freight.component';
import { ConfirReceiptComponent } from '../../modal/bulk/confir-receipt/confir-receipt.component';
import { of } from 'rxjs';
import { ShipperBaseService } from '@shared';
import { Router } from '@angular/router';


@Component({
  selector: 'app-supply-management-bulk',
  templateUrl: './bulk.component.html',
  styleUrls: ['./bulk.component.less']
})
export class OrderManagementBulkComponent implements OnInit {
  ui: SFUISchema = {};
  uiView: SFUISchema = {};
  schema: SFSchema = {};
  schemaView: SFSchema = {};
  auditMany = false;
  isVisibleView = false;
  isVisibleEvaluate = false;
  isVisible = false;
  _$expand = false;
  changeId: any;       // 主页面查看运费变更记录id - 用于运费变更记录
  changeViewId: any;  // 查看运费变更记录id - 用于查看
  ViewCause: any;  // 变更运费查看数据
  sfViewFormData: any;  // 变更运费查看的sf 数据
  @ViewChild('st') private readonly st!: STComponent;
  @ViewChild('stFloat') private readonly stFloat!: STComponent;
  @ViewChild('stFloatView') private readonly stFloatView!: STComponent;
  @ViewChild('sf', { static: false }) sf!: SFComponent;
  @ViewChild('sfFre', { static: false }) sfFre!: SFComponent;
  @ViewChild('sfView', { static: false }) sfView!: SFComponent;
  columns: STColumn[] = [];
  columnsFloat: STColumn[] = [];
  columnsFloatView: STColumn[] = [];
  demoValue: any;
  resourceStatus: any;
  datass: any = [
    {
    one: '1',
    two: '1',
    three: '1',
    id: 1
   },
    {
    one: '2',
    two: '2',
    three: '2',
    id: 2
   },
];
tabs = {
  cancelQuantity: 0,
  receivedQuantity: 0,
  stayQuantity: 0
};
  constructor(
    public service: OrderManagementService,
    private modal: NzModalService,
    public service2: ShipperBaseService,
    private router: Router,
     
     ) { }

  /**
 * 查询参数
 */
   get reqParams() {
    const a:any = {};
    if(this.resourceStatus) {
      a.billStatus = this.resourceStatus + 1;
    }
    return {
      ...a,
      ...this.sf?.value,
    };
  }
  get selectedRows() {
    return this.st?.list.filter((item) => item.checked) || [];
  }
  get changeParams() {
    return {
      id: this.changeId
    };
  }
  getGoodsSourceStatistical() {
    this.service.request(this.service.$api_getBulkStatistical).subscribe(res => {
      if (res) {
       res.forEach((element: any) => {
        if(element.statusLabel === '待发车') {
          this.tabs.stayQuantity = element.quantity
        } else if (element.statusLabel === '待接单') {
          this.tabs.receivedQuantity = element.quantity
        } else if (element.statusLabel === '待签收') {
          this.tabs.cancelQuantity = element.quantity
        } 
       });
      }
    })
  }
  selectChange(e: number) {
    console.log(e);
    this.resourceStatus = e;
    this.initST();
    setTimeout(() => {
      this.st.load();
    }, 500);
  }
  ngOnInit(): void {
    this.getGoodsSourceStatistical()
    this.initSF();
    this.initST();
    this.initSTFloat();
    this.initSTFloatView();
    this.initSFView();
  }



  /**
 * 初始化查询表单
 */
  initSF() {
    this.schema = {
      properties: {
        _$expand: { type: 'boolean', ui: { hidden: true } },
        billCode: {
          type: 'string',
          title: '订单号'
        },
        resourceCode: {
          type: 'string',
          title: '货源编号'
        },
        shipperAppUserId: {
          type: 'string',
          title: '货主'
        },
        loadingPlace: {
          type: 'string',
          title: '装货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        dischargePlace: {
          type: 'string',
          title: '卸货地',
          ui: {
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          }
        },
        driverId: {
          title: '承运司机',
          type: 'string',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_get_getDriverInfo, { keyword: q, model: 1, type: 1 })
                  .pipe(map(res => (res as any[]).map(i => ({ label: i.name, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFSelectWidgetSchema
        },

        carNo: { 
          title: '车牌号',
          type: 'string',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_get_getCarLicenseListByCarNo, {
                    carNo: q
                  })
                  .pipe(map((res: any[]) => (res as any[]).map((i) => ({ label: i.carNo, value: i.carNo } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
         },
         payeeId: {
          title: '车队长',
          type: 'string',
          ui: {
            widget: 'select',
            serverSearch: true,
            searchDebounceTime: 300,
            searchLoadingText: '搜索中...',
            onSearch: (q: any) => {
              if (!!q) {
                return this.service
                  .request(this.service.$api_get_getDriverInfo, { keyword: q,
                  model: 1, type: 2 })
                  .pipe(map((res) => (res as any[]).map((i) => ({ label: i.name, value: i.id } as SFSchemaEnum))))
                  .toPromise();
              } else {
                return of([]);
              }
            },
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        }, 
        paymentstatus: {
          title: '支付状态',
          type: 'string',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'payment:status' },
            containAllLable:true,
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        },
        createTime: {
          title: '创建时间',
          type: 'string',
          ui: {
            widget: 'date',
            mode: 'range',
            format: 'yyyy-MM-dd',
            visibleIf: {
              _$expand: (value: boolean) => value
            }
          } as SFDateWidgetSchema
        },
        isRiskSheet: {
          type: 'string',
          title: '是否风险单',
          enum: [
            { label: '全部', value: '' },
            { label: '是', value: '1' },
            { label: '否', value: '2' }
          ],
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          },
        },
        enterpriseInfoName: {
          type: 'string',
          title: '网络货运人',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
            allowClear: true,
            asyncData: () => this.service2.getNetworkFreightForwarder(),
          },
        },
        goodsName: {
          type: 'string',
          title: '货物名称',
          ui: {
            widget: 'select',
            placeholder: '请选择',
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
            allowClear: true,
            asyncData: () => this.getCatalogueMember(),
          },
        },
        serviceType: {
          title: '服务类型',
          type: 'string',
          default: '',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'service:type' },
            containAllLable:true,
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        },
      },
      type: 'object'
    };
    this.ui = { '*': { spanLabelFixed: 110, grid: { span: 8, gutter: 4 } } };
  }
  /**
 * 初始化查询表单
 */
  initSFView() {
    this.schemaView = {
      properties: {
        freightPrice: {
          type: 'string',
          title: '运费单价',
        },
        rule: {
          title: '',
          type: 'string',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'goodresource:rounding:rules' },
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        },
        settlementBasis: {
          type: 'string',
          title: '结算重量',
          ui: {
            widget: 'dict-select',
            params: { dictKey: 'goodresource:settlement:type' },
            visibleIf: {
              _$expand: (value: boolean) => value,
            },
          } as SFSelectWidgetSchema,
        },
      },
    };
    this.uiView = { '*': { spanLabelFixed: 80, grid: { span: 12, gutter: 4 } } };
  }

  /**
   * 初始化数据列表
   */
  initST() {
    this.columns = [
      { title: '', type: 'checkbox', width: '50px', className: 'text-center' },
      {
        title: '订单号',
        width: '100px',
        className: 'text-center',
        render: 'billCode'
      },
      {
        title: '运费明细',
        width: '100px',
        className: 'text-center',
        render: 'mybidDetailInfo',
      },
      { title: '网络货运人', index: 'enterpriseInfoName', width: '120px', className: 'text-center' },
      { title: '托运人', index: 'enterpriseProjectName', width: '120px', className: 'text-center' },
      { title: '关联运单号', index: 'wayBillCode', width: '120px', className: 'text-center' },
      { title: '货源编号', index: 'resourceCode', width: '120px', className: 'text-center' },
      { title: '装货地', index: 'loadingAddressArr', width: '120px', className: 'text-center' },
      {
        title: '卸货地',
        className: 'text-center',
        width: '120px',
        index: 'unloadingAddressArr'
      },
      {
        title: '货物信息',
        className: 'text-center',
        width: '120px',
        render: 'goodsName'
      }, {
        title: '运费单价',
        className: 'text-center',
        width: '120px',
        index: 'freightPrice'
      },
      {
        title: '接单数量',
        className: 'text-center',
        index: 'goodsNumber',
        width: '100px',
      },
      {
        title: '结算重量',
        className: 'text-center',
        index: 'settlementWeight',
        width: '100px',
      },
      {
        title: '承运司机',
        className: 'text-center',
        index: 'driverName',
        width: '100px',
      },
      {
        title: '收款人',
        className: 'text-center',
        index: 'payeeName',
        width: '100px',
      },
      {
        title: '装卸货时间',
        width: '170px',
        className: 'text-center',
        render: 'loadingTime'
      },
      {
        title: '创建时间',
        className: 'text-center',
        index: 'createTime',
      },
      {
        title: '操作',
        fixed: 'right',
        width: '200px',
        className: 'text-left',
        buttons: [
          {
            text: '查看评价',
            click: (_record) => this.viewEvaluate(_record),
            iif: item => item.billStatus == '5',
          },
          {
            text: '运费变更记录',
            click: (_record) => this.OpenPrice(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3' || item.billStatus == '6', 
          },
          {
            text: '变更运费',
            click: (_record) => this.updateFreight(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3',
          },
          {
            text: '确认签收',
            click: (_record) => this.confirmReceipt(_record),
            iif: item => item.billStatus == '4',
          },
          {
            text: '取消订单',
            click: (_record) => this.cancellation(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3' || item.billStatus == '1',
          },
          {
            text: '修改订单',
            click: (_record) => this.changeOrder(_record),
            iif: item => item.billStatus == '4' || item.billStatus == '5' || item.billStatus == '2' || item.billStatus == '3',
          },
        ],
      },
    ];
  }
  initSTFloat() {
    this.columnsFloat = [
      {
        title: '序号',
        className: 'text-center',
        render: 'order'
      },
      {
        title: '操作时间',
        className: 'text-center',
        index: 'applyTime'
      },
      {
        title: '操作人',
        className: 'text-center',
        index: 'applyUserName'
      },
      { title: '状态',     index: 'handleStatus',  className: 'text-center' },
      {
        title: '操作',
        fixed: 'right',
        className: 'text-left',
        buttons: [
          {
            text: '查看',
            click: (_record) => this.FloatView(_record),
          },
          // {
          //   text: '查看协议',
          //   click: (_record, _modal, _instance) => this.view(_record)
          // },
          {
            text: '撤销',
            click: (_record) => this.revoke(_record),
           iif: item => item.handleStatus === '1' || item.handleStatus === 1,
          },
        ],
      },
    ];
  }
  initSTFloatView() {
    this.columnsFloatView = [
      {
        title: '费用名称',
        width: '100px',
        className: 'text-center',
        index: 'costName'
      },
      {
        title: '变更前',
        width: '100px',
        className: 'text-center',
        index: 'amountAfterChange'
      },
      { title: '变更值', index: 'amountchangeValue', width: '120px', className: 'text-center' },
      { title: '变更后', index: 'amountBeforeChange', width: '120px', className: 'text-center' }
    ];
  }
  /**
   * 查询字段个数
   */
  get queryFieldCount(): number {
    return Object.keys(this.schema?.properties || {}).length;
  }
  get changeViewParams() {
    return {
      id: this.changeViewId
    };
  }
  /**
  * 伸缩查询条件
  */
  expandToggle(): void {
    this._$expand = !this._$expand;
    this.sf?.setValue('/_$expand', this._$expand);
  }
  tabChange(item: any) {
    console.log(item)
  }
  /**
   * 重置表单
   */
  resetSF(): void {
    this.sf.reset();
    this._$expand = false;
  }



  getCatalogueMember() {
    const params = {
    };
    return this.service.request(this.service.$api_get_catalogue_member, params, 'GET').pipe(
      map((res) => {
        if (res) {
          console.log(res)
        }
      }),
    );
  }

  /**
   * 导入货源
   */
  importGoodsSource() {

  }
  audit(item: any) {
    console.log(item)
  }

 /*
  * 审核关闭弹窗
  view: 1
  浮动费用： 0
  查看评价： 3
  */
  handleCancel(type: string) {
    console.log(type)
    if(type === '0') {
      this.isVisible = false
    } else if(type === '1') {
    console.log(type)
      this.isVisibleView = false
    } else if(type === '2') {
    console.log(type)
      this.isVisibleEvaluate = false
    }
  }
    /**
  * 审核通过按钮
  */
  handleOK() {
    
  }
  OpenPrice(item: any) {
    this.changeId = item.id;
    this.isVisible = true
  }
   /**
  * 浮动费用查看
  */
  FloatView(item: any) {
    console.log(item)
    this.changeViewId = item.id;
    this.service.request(this.service.$api_getChangeRecordBulkDetail, {id: this.changeViewId}).subscribe((res) => {
      this.ViewCause = res;
    })
    this.isVisibleView = true
  }
   /**
  *查看评价
  */
  viewEvaluate(item: any) {
    console.log(item)
    this.isVisibleEvaluate = true
  }
    /**
   *变更运费
   */
   updateFreight(item: any) {
    this.service.request(this.service.$api_getFreightChangeBulkDetail, { id: item.id }).subscribe(data => {
      if (data) {
        const modal = this.modal.create({
          nzTitle: '变更运费',
          nzWidth: 580,
          nzContent: UpdateFreightComponent,
          nzComponentParams: { data: { ...data, billId: item.id } },

        });
        modal.afterClose.subscribe(_ => this.st.reload());
      }
    });
  }
 
  //  *确认签收
   
   confirmReceipt(item: any) {
    const modalRef = this.modal.create({
      nzTitle: '确认签收',
      nzWidth: '50%',
      nzContent: ConfirReceiptComponent,
      nzComponentParams: {
        i: item,
        Status: 1
      },
      nzFooter: null
    });
    modalRef.afterClose.subscribe((result: any) => {
        this.st.load(1);
    });
  }
  userAction() {
    let params: any[] = [];
    this.selectedRows.forEach(item => {
      params.push(item.id);
    });
    console.log(this.selectedRows)
    console.log(params)
    this.service.request(this.service.$api_get_batchSignBulkOrder, params).subscribe(res => {
      if (res) {
        this.st.load(1);
        console.log(res);
      } else {
        this.service.msgSrv.error(res.msg);
      }
    });
  }
      // 取消订单
      cancellation(item: any) {
        // api_get_cancelAnOrder
        this.modal.confirm({
          nzTitle: '<b>确定取消该订单吗?</b>',
          nzContent: `<b>取消后无法恢复，请确认</b>`,
          nzOnOk: () =>
            this.service.request(this.service.$api_get_cancelAnOrder, {id: item.id}).subscribe((res) => {
              if (res === true) {
                this.service.msgSrv.success('操作成功！');
                this.st?.reload(1);
                this.initST();
              }
              this.st?.reload(1);
            }),
        })
      }
      revoke(item: any) {
        this.modal.confirm({
          nzTitle: '是否确定立即撤销费用变更！</i>',
          nzOnOk: () => 
          this.service.request(this.service.$api_get_revokeChangeRecord, { id: item.id}).subscribe((res) => {
            console.log(res)
            if(res) {
              this.service.msgSrv.success('撤销成功！')
              this.stFloat.reload()
              this.st?.reload(1);
            } else {
              this.service.msgSrv.error(res.msg)
            }
          })
        });
      }
          // 修改订单
   changeOrder(value: any) {
    this.router.navigate(['order-management/bulk-detailChange', value.id])
   }
}
